package internal

import (
	"context"
	"github.com/gogf/gf/v2/util/guid"
	"yx-dataset-server/app/errors"
	"yx-dataset-server/app/model"
	"yx-dataset-server/app/schema"
)

// NewRoleMenu 创建RoleMenu
func NewRoleMenu(mRoleMenu model.IRoleMenu) *RoleMenu {
	return &RoleMenu{
		RoleMenuModel: mRoleMenu,
	}
}

// RoleMenu 创建RoleMenu对象
type RoleMenu struct {
	RoleMenuModel model.IRoleMenu
}

// Query 查询数据
func (a *RoleMenu) Query(ctx context.Context, params schema.RoleMenuQueryParam, opts ...schema.RoleMenuQueryOptions) (*schema.RoleMenuQueryResult, error) {
	return a.RoleMenuModel.Query(ctx, params, opts...)
}

// Get 查询指定数据
func (a *RoleMenu) Get(ctx context.Context, recordID string, opts ...schema.RoleMenuQueryOptions) (*schema.RoleMenu, error) {
	item, err := a.RoleMenuModel.Get(ctx, recordID, opts...)
	if err != nil {
		return nil, err
	} else if item == nil {
		return nil, errors.ErrNotFound
	}
	return item, nil
}

func (a *RoleMenu) getUpdate(ctx context.Context, recordID string) (*schema.RoleMenu, error) {
	return a.Get(ctx, recordID)
}

// Create 创建数据
func (a *RoleMenu) Create(ctx context.Context, item schema.RoleMenu) (*schema.RoleMenu, error) {
	item.RecordId = guid.S()
	err := a.RoleMenuModel.Create(ctx, item)
	if err != nil {
		return nil, err
	}
	return a.getUpdate(ctx, item.RecordId)
}

// Update 更新数据
func (a *RoleMenu) Update(ctx context.Context, recordID string, item schema.RoleMenu) (*schema.RoleMenu, error) {
	oldItem, err := a.RoleMenuModel.Get(ctx, recordID)
	if err != nil {
		return nil, err
	} else if oldItem == nil {
		return nil, errors.ErrNotFound
	}
	err = a.RoleMenuModel.Update(ctx, recordID, item)
	if err != nil {
		return nil, err
	}
	return a.getUpdate(ctx, recordID)
}

// Delete 删除数据
func (a *RoleMenu) Delete(ctx context.Context, recordID string) error {
	oldItem, err := a.RoleMenuModel.Get(ctx, recordID)
	if err != nil {
		return err
	} else if oldItem == nil {
		return errors.ErrNotFound
	}

	return a.RoleMenuModel.Delete(ctx, recordID)
}

// UpdateStatus 更新状态
func (a *RoleMenu) UpdateStatus(ctx context.Context, recordID string, status int) error {
	oldItem, err := a.RoleMenuModel.Get(ctx, recordID)
	if err != nil {
		return err
	} else if oldItem == nil {
		return errors.ErrNotFound
	}
	return a.RoleMenuModel.UpdateStatus(ctx, recordID, status)
}
